# Hunter's Hit Sounds Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/hit_sounds/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load hit_sounds
#
################################################################################
#import EventScripts
import es
#import Libraries
import gamethread
import settinglib
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Hit Sounds"
info.version = "3.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "This scriptaddon adds hitsounds to your server"
info.basename = "hit_sounds"

hunter_hit_sounds_ver   = info.version
hunter_hit_sounds_text  = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Server Variables
hit_sounds_savetime     = es.ServerVar('hit_sounds_savetime', '30', 'How much days should inactive users be stored, before their settings get deleted? ( default = 30 )')
hit_sounds_soundload    = es.ServerVar('hit_sounds_soundload', '1', 'Should the sounds be downloaded with EventScripts?')
hit_sounds_default      = es.ServerVar('hit_sounds_default', '1', 'Default settings for new connecting players')

# Settinglib Object
hit_sounds_setting      = settinglib.create('hitsounds', 'Hit Sounds Setting', 'toggle')

def load():
    public = es.ServerVar('hu_hs', info.version, info.name)
    public.makepublic()

    hit_sounds_setting.addoption('headshot', 'Headshot Sound')
    hit_sounds_setting.addoption('teammate', 'Teammate Sound')
    hit_sounds_setting.addoption('normal', 'Normal Sound')
    hit_sounds_setting.setdefault('headshot', str(hit_sounds_default))
    hit_sounds_setting.setdefault('teammate', str(hit_sounds_default))
    hit_sounds_setting.setdefault('normal', str(hit_sounds_default))
    hit_sounds_setting.addsound('ui/buttonclick.wav')

    es.regsaycmd('!hitsounds', 'hit_sounds/saycmd', 'Hit Sounds Setting')
    es.log(hunter_hit_sounds_text)
    es.msg('#multi', '#green[HitSounds] #defaultLoaded')
    
def unload():
    es.unregsaycmd('!hitsounds')
    es.msg('#multi', '#green[HitSounds] #defaultUnloaded')
    
def es_map_start(event_var):
    hit_sounds_setting.clear(int(hit_sounds_savetime)*86400)
    if int(hit_sounds_soundload):
        es.stringtable('downloadables', 'sound/player/hitsounds/headshot.wav')
        es.stringtable('downloadables', 'sound/player/hitsounds/hit.wav')
        es.stringtable('downloadables', 'sound/player/hitsounds/hitteammate.wav')

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_hit_sounds_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_hit_sounds_text)

def player_activate(event_var):
    hit_sounds_setting.updateTime(int(event_var['userid']))
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_hit_sounds_text))
    gamethread.delayed(15, es.tell, (int(event_var['userid']), '#multi', '#green[HitSounds] #defaultSay \'!hitsounds\' for settings menu'))

def player_disconnect(event_var):
    hit_sounds_setting.updateTime(int(event_var['userid']))

def player_hurt(event_var):
    userid = int(event_var['userid'])
    attackerid = int(event_var['attacker'])
    if not es.isbot(attackerid):
        if int(event_var['es_userteam']) == int(event_var['es_attackerteam']):
            if userid != attackerid:
                if hit_sounds_setting.get('teammate', attackerid):
                    es.playsound(attackerid, 'player/hitsounds/hitteammate.wav', 1.0)
        elif int(event_var['hitgroup']) == 1:
            if hit_sounds_setting.get('headshot', attackerid):
                es.playsound(attackerid, 'player/hitsounds/headshot.wav', 1.0)
        else:
            if hit_sounds_setting.get('normal', attackerid):
                es.playsound(attackerid, 'player/hitsounds/hit.wav', 1.0)

def saycmd():
    hit_sounds_setting.send(int(es.getcmduserid()))
